--- asterisk-16.21.1/res/res_pjsip_diversion.c	2021-10-11 19:37:25.000000000 +0100
+++ asterisk-16.21.1.diversion/res/res_pjsip_diversion.c	2021-10-24 17:49:41.168889784 +0100
@@ -501,7 +501,7 @@
  * \param tdata The outbound message
  * \param data The redirecting data used to fill parts of the diversion header
  */
-static void add_diversion_header(pjsip_tx_data *tdata, struct ast_party_redirecting *data)
+static void add_diversion_header(pjsip_tx_data *tdata, struct ast_channel *chan)
 {
 	static const pj_str_t reason_name = { "reason", 6 };
 
@@ -515,17 +515,17 @@
 	char *reason_buf;
 	pjsip_uri *base;
 
-	struct ast_party_id *id = NULL;
+	struct ast_party_id id;
 	if (tdata->msg->type == PJSIP_REQUEST_MSG) {
-		id = &data->from;
+		id = ast_channel_redirecting_effective_from(chan);
 	} else {
 		/* In responses indicate the new destination */
-		id = &data->to;
+		id = ast_channel_redirecting_effective_to(chan);
 	}
 
 	base = PJSIP_MSG_FROM_HDR(tdata->msg)->uri;
 
-	if (!id->number.valid || ast_strlen_zero(id->number.str)) {
+	if (!id.number.valid || ast_strlen_zero(id.number.str)) {
 		return;
 	}
 
@@ -536,13 +536,13 @@
 	name_addr = pjsip_uri_clone(tdata->pool, base);
 	uri = pjsip_uri_get_uri(name_addr->uri);
 
-	pj_strdup2(tdata->pool, &name_addr->display, id->name.str);
-	pj_strdup2(tdata->pool, &uri->user, id->number.str);
+	pj_strdup2(tdata->pool, &name_addr->display, id.name.str);
+	pj_strdup2(tdata->pool, &uri->user, id.number.str);
 
 	param = PJ_POOL_ALLOC_T(tdata->pool, pjsip_param);
 	param->name = reason_name;
 
-	reason_str = reason_code_to_str(&data->reason);
+	reason_str = reason_code_to_str(&ast_channel_redirecting(chan)->reason);
 
 	/* Reason is either already quoted or it is a token to not need quotes added. */
 	quote_str = *reason_str == '\"' || sip_is_token(reason_str) ? "" : "\"";
@@ -656,7 +656,7 @@
 
 	if (session->channel && session->endpoint->id.send_diversion &&
 	    (data = ast_channel_redirecting(session->channel))->count) {
-		add_diversion_header(tdata, data);
+		add_diversion_header(tdata, session->channel);
 	}
 	if (session->channel && session->endpoint->id.send_history_info) {
 		data = ast_channel_redirecting(session->channel);
